
#define TEST_DISABLE_MATH_FUNCS //return PATCH_RET_NOT_PROCESSED;


/*
0x80324258: <0xafa40000> SW        a0 -> 0x0000(sp)
0x8032425c: <0xafa50004> SW        a1 -> 0x0004(sp)
0x80324260: <0xafa60008> SW        a2 -> 0x0008(sp)
0x80324264: <0xafa7000c> SW        a3 -> 0x000c(sp)
0x80324268: <0xdfaf0008> LD        t7 <- 0x0008(sp)
0x8032426c: <0xdfae0000> LD        t6 <- 0x0000(sp)
0x80324270: <0x01cf001d> DMULTU    t6 * t7
0x80324274: <0x00001012> MFLO      v0
0x80324278: <0x0002183c> DSLL32    v1 = v0 << 0x0020
0x8032427c: <0x0003183f> DSRA32    v1 = v1 >> 0x0020
0x80324280: <0x03e00008> JR        ra
0x80324284: <0x0002103f> DSRA32    v0 = v0 >> 0x0020

DMULTU
	g_qwMultLO = (u64)g_qwGPR[dwRS] * (u64)g_qwGPR[dwRT];
	g_qwMultHI = 0;
DSLL32
	g_qwGPR[dwRD] = g_qwGPR[dwRT] << (32 + dwSA);
DSRA32
	g_qwGPR[dwRD] = (s64)g_qwGPR[dwRT] >> (32 + dwSA);

*/

DWORD Patch___ll_mul()
{
TEST_DISABLE_MATH_FUNCS
	DWORD dwHiA = (u32)g_qwGPR[REG_a0];
	DWORD dwLoA = (u32)g_qwGPR[REG_a1];
	DWORD dwHiB = (u32)g_qwGPR[REG_a2];
	DWORD dwLoB = (u32)g_qwGPR[REG_a3];

	u64 qwA = ((u64)dwHiA << 32) | (u64)dwLoA;
	u64 qwB = ((u64)dwHiB << 32) | (u64)dwLoB;

	u64 qwR = qwA * qwB;

	g_qwGPR[REG_v0] = (s64)qwR >> 32;
	g_qwGPR[REG_v1] = (s64)(s32)(qwR & 0xFFFFFFFF);

	return PATCH_RET_JR_RA;
}


DWORD Patch_sqrtf()
{
TEST_DISABLE_MATH_FUNCS
	f32 f = ToFloat(g_qwCPR[1][12]);
	ToFloat(g_qwCPR[1][00]) = sqrtf(f);
	return PATCH_RET_JR_RA;
}



DWORD Patch_sinf()
{
TEST_DISABLE_MATH_FUNCS
	// FP12 is input
	// FP00 is output
	f32 f = ToFloat(g_qwCPR[1][12]);

	f32 r = sinf(f);

	//DBGConsole_Msg(0, "sinf(%f) = %f (ra 0x%08x)", f, r, (DWORD)g_qwGPR[REG_ra]);

	ToFloat(g_qwCPR[1][00]) = r;

/*	g_dwNumCosSin++;
	if ((g_dwNumCosSin % 100000) == 0)
	{
		DBGConsole_Msg(0, "%d sin/cos calls intercepted", g_dwNumCosSin);
	}*/
	return PATCH_RET_JR_RA;

}
DWORD Patch_cosf()
{
TEST_DISABLE_MATH_FUNCS
	// FP12 is input
	// FP00 is output
	f32 f = ToFloat(g_qwCPR[1][12]);

	f32 r = cosf(f);

	//DBGConsole_Msg(0, "cosf(%f) = %f (ra 0x%08x)", f, r, (DWORD)g_qwGPR[REG_ra]);

	ToFloat(g_qwCPR[1][00]) = r;

/*	g_dwNumCosSin++;
	if ((g_dwNumCosSin % 100000) == 0)
	{
		DBGConsole_Msg(0, "%d sin/cos calls intercepted", g_dwNumCosSin);
	}*/
	return PATCH_RET_JR_RA;

}
